package net.ihe.gazelle.simulator.sut.model;
/**
 * metadata/Usage.java
 * <p>
 * File generated from the Usage uml Class
 * Generated by the Acceleo UML 2.1 to Java generator module (Obeo)
 */

// End of user code

import net.ihe.gazelle.hql.FilterLabel;
import net.ihe.gazelle.simulator.common.tf.model.AffinityDomain;
import net.ihe.gazelle.simulator.common.tf.model.Transaction;
import org.jboss.seam.annotations.Name;

import javax.persistence.*;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlTransient;
import java.io.Serializable;


/**
 * Description of the class Usage.
 *
 * @author aberge
 * @version $Id: $Id
 */
@Entity
@Name("usage")
@Table(name = "usage_metadata",
        schema = "public",
        uniqueConstraints = @UniqueConstraint(
                name = "unique_usage_metadata", columnNames = {"transaction_id", "affinity_id"}
        ))
@SequenceGenerator(name = "usage_sequence", sequenceName = "usage_id_seq", allocationSize = 1)
@XmlAccessorType(XmlAccessType.FIELD)
public class Usage implements Serializable, Comparable<Usage> {

    /**
     *
     */
    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "usage_sequence")
    @Column(name = "id", unique = true, nullable = false)
    @XmlTransient
    public Integer id;

    /**
     * this parameter is used in other simulators
     */
    @Column(name = "keyword")
    public String keyword;

    @ManyToOne(cascade = {CascadeType.PERSIST, CascadeType.MERGE})
    @JoinColumn(name = "transaction_id")
    public Transaction transaction;

    @ManyToOne(cascade = {CascadeType.PERSIST, CascadeType.MERGE})
    @JoinColumn(name = "affinity_id")
    public AffinityDomain affinity;

    public String action;

    /**
     * Return transaction.
     *
     * @return transaction
     */
    public Transaction getTransaction() {
        return transaction;
    }

    /**
     * Set a value to attribute transaction.
     *
     * @param transaction a {@link net.ihe.gazelle.simulator.common.tf.model.Transaction} object.
     */
    public void setTransaction(Transaction transaction) {
        this.transaction = transaction;
    }


    /**
     * Return affinity.
     *
     * @return affinity
     */
    public AffinityDomain getAffinity() {
        return affinity;
    }

    /**
     * Set a value to attribute affinity.
     *
     * @param affinity a {@link net.ihe.gazelle.simulator.common.tf.model.AffinityDomain} object.
     */
    public void setAffinity(AffinityDomain affinity) {
        this.affinity = affinity;
    }


    /**
     * Return action.
     *
     * @return action
     */
    public String getAction() {
        return action;
    }

    /**
     * Set a value to attribute action.
     *
     * @param action a {@link java.lang.String} object.
     */
    public void setAction(String action) {
        this.action = action;
    }


    /**
     * Return id.
     *
     * @return id
     */
    public Integer getId() {
        return id;
    }

    /**
     * Set a value to attribute id.
     *
     * @param id a {@link java.lang.Integer} object.
     */
    public void setId(Integer id) {
        this.id = id;
    }

    /**
     * <p>Getter for the field <code>keyword</code>.</p>
     *
     * @return a {@link java.lang.String} object.
     */
    @Deprecated
    public String getKeyword() {
        return keyword;
    }

    /**
     * <p>Setter for the field <code>keyword</code>.</p>
     *
     * @param keyword a {@link java.lang.String} object.
     */
    @Deprecated
    public void setKeyword(String keyword) {
        this.keyword = keyword;
    }

    /**
     * <p>getLabelForFilter.</p>
     *
     * @return a {@link java.lang.String} object.
     */
    @FilterLabel
    public String getLabelForFilter() {
        return affinity.getLabelToDisplay() + " => " + transaction.getKeyword() + " (" + action + ")";
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((action == null) ? 0 : action.hashCode());
        result = prime * result + ((affinity == null) ? 0 : affinity.hashCode());
        result = prime * result + ((keyword == null) ? 0 : keyword.hashCode());
        result = prime * result + ((transaction == null) ? 0 : transaction.hashCode());
        return result;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        Usage other = (Usage) obj;
        if (action == null) {
            if (other.action != null) {
                return false;
            }
        } else if (!action.equals(other.action)) {
            return false;
        }
        if (affinity == null) {
            if (other.affinity != null) {
                return false;
            }
        } else if (!affinity.equals(other.affinity)) {
            return false;
        }
        if (keyword == null) {
            if (other.keyword != null) {
                return false;
            }
        } else if (!keyword.equals(other.keyword)) {
            return false;
        }
        if (transaction == null) {
            if (other.transaction != null) {
                return false;
            }
        } else if (!transaction.equals(other.transaction)) {
            return false;
        }
        return true;
    }


    /**
     * {@inheritDoc}
     */
    @Override
    public int compareTo(Usage o) {
        return getLabelForFilter().compareTo(o.getLabelForFilter());
    }
}
